#include "common.h"

//-------------------------------------------------------------
// This is base^n, so this can (attempt to) excede MAX_INT 2147483647
// if base^n >2^31, or 
// base     n
// -------------
//  2       31
//  3     > 19
//  4     > 15
//  5     > 13
//  6     > 11
//  7     > 11
//  8     > 10
//  9      > 9
// 10      > 9
// 11      > 8
// ...
// The base here will be 2 for the forseeable future and the genome
// is 9 bits.
// This should be reviewed if the genome size grows to 30+ bits or
// the genome is something other than an array of bits.
//
int power(int base, int n)
{
  int p=1 ;
  for (int i=1 ; i<=n ; ++i)
  {
     p = p * base ;
  }
  return p ;
}

//-------------------------------------------------------------
// Convert an array of integer to a single integer, assuming
// that the array contains only 0 and 1 values.
// About bounds checking. The maximum int
// INT_MAX is 2147483647, or 2^31 -1, or 7FFF FFFF, so the only
// way a genome could excede INT_MAX is if the genome was 32 bits
// long. That is not this subroutine's problem.
// 
int genomeAsInteger(int bitsInArray, int* theMember)
{
   int n = 0;
   for (int i=0 ; i<bitsInArray ; i++)
   {
      if (theMember[i] > 0)
      {
         n = n + power(2,i) ;
      }
   }
   return n ;
}


