#include "common.h"
#include "gaga.h"

using namespace std;

/* This is a simple test harness for the GA called gaga.
 *
 */

#define TALK

int main()
{
   int fitMult = 10 ;
   int muteBias = 4 ;
   int muteProb = 50 ;
   int iterations = 25 ;

   int bit ;
   int nada ;
   int membr ;
   int param0 = 0 ;
   int param1 = 0 ;
   int param2 = 0 ;
   int param3 = 0 ;
   int theEnvironment[ENVIRONMENT_LENGTH] ;
   int theCommunity[MEMBERS][GENOME_BITS] ;

   srand(RANDSEED) ;
    
   // Create the environment. This is a simple triangle
   // which peaks in the middle.
   //
#ifdef TALK
   cout << "\nThe optimum point in the environment of 512 bits is currently 256" << endl ;
#endif
   for (bit = 0; bit < ENVIRONMENT_LENGTH; bit++)
   {
      if (bit < ENVIRONMENT_LENGTH/2) {
         theEnvironment[bit] = 2*bit ;
      }
      else
      {
         theEnvironment[bit] = 2*(ENVIRONMENT_LENGTH - bit) ;
      }
   }

   // Initial randomization of all community members genes.
   //
#ifdef TALK
   cout << "\nThe original genomes of each member:\n" ;
#endif
   for (membr=0;membr<MEMBERS;membr++)
   {
      for (bit=GENOME_BITS-1;bit>=0;bit--)
      {
         theCommunity[membr][bit] = rand() % 2;
      }
#ifdef TALK
      cout << genomeAsInteger(GENOME_BITS, theCommunity[membr]) << " " ;
#endif
   }
#ifdef TALK
   cout << "\n" << endl ;

   cout << "\nThe genomes of the members after each iteration:" ;
#endif
   for (int iter=0 ; iter < iterations ; iter++) 
   {
      nada = gaga(
                  muteProb,
                  muteBias,
                  fitMult,
                  theEnvironment,
                  theCommunity,
                  param0,
                  param1,
                  param2,
                  param3
                  ) ;    

#ifdef TALK
      cout << "\n" ;
#endif
      for (membr=0;membr<MEMBERS;membr++)
      {
#ifdef TALK
         cout << genomeAsInteger(GENOME_BITS, theCommunity[membr]) << " " ;
#endif
      }
   }
#ifdef TALK
   cout << "\n" ;
#endif
}


